<template>
  <div class="flex pb-[20px] px-4">
    <div class="my-0 mx-auto py-0 max-w-[100%]">
      <div class="m-0 relative">
        <div class="flex overflow-auto w-full pt-3 remove-scroll-bar">
          <template v-for="TopNewType in TopNewTypes" :key="TopNewType">
            <nuxt-link :to="`/games/${TopNewType.split(' ').join('')}__n__gt`">
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-[88px]">
                  <div
                    class="games-types__item-link"
                    :class="{
                      active: activeTab.includes(
                        String(TopNewType.replace(' ', ''))
                      ),
                    }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${TopNewType.split(
                            ' '
                          )
                            .join('')
                            .toLowerCase()}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] text-center font-semibold whitespace-nowrap overflow-hidden uppercase w-[80px] truncate"
                  >
                    {{ TopNewType }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </template>
          <template v-for="gameType in gameTypes" :key="gameType">
            <nuxt-link :to="`/games/${gameType}__n__gt`">
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-[88px]">
                  <div
                    class="games-types__item-link"
                    :class="{ active: activeTab.includes(gameType) }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${gameType}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] text-center font-semibold whitespace-nowrap overflow-hidden uppercase w-[80px] truncate"
                  >
                    {{ gameType }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </template>
          <template v-for="provider in providers" :key="provider">
            <nuxt-link
              :to="
                provider.IsMaintain
                  ? ''
                  : `/games/${provider.ProviderName}__n__gp`
              "
              :class="{ 'grayscale-[1] cursor-[unset]': provider.IsMaintain }"
            >
              <div class="group w-full">
                <div class="flex flex-col items-center justify-center w-[88px]">
                  <div
                    class="games-types__item-link"
                    :class="{
                      active: activeTab.includes(provider.ProviderName),
                    }"
                  >
                    <img
                      class="game-filter-icon"
                      :src="
                        handleImportImage(
                          `/black_modern_1/images/gameIcons/${provider.ProviderName.split(
                            ' '
                          )
                            .join('')
                            .toLowerCase()}.png`
                        )
                      "
                      alt="logo"
                    />
                  </div>
                  <div
                    class="text-[11px] text-center font-semibold whitespace-nowrap overflow-hidden uppercase w-[80px] truncate"
                  >
                    {{ provider.GameProviderDisplayName }}
                  </div>
                </div>
              </div>
            </nuxt-link>
          </template>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { Navigation } from "swiper";
import commonHelper from "@/utils/commonHelper";
import { store } from "@/store";
import { useGameEntryComponent } from "@/composables/useTheme";

export default defineComponent({
  setup() {
    const route = useRoute();
    const isGamePage = computed(() => route.matched[0].name === "GameInitial");
    const { getAssetImage } = commonHelper;
    const handleImportImage = (path = "") => {
      try {
        return getAssetImage(`assets/theme${path}`);
      } catch (e) {
        return path;
      }
    };
    const TopNewTypes = ["Hot Games", "New Games", "Favorite"];
    const gameTypes = computed(
      () => store.state.gameTabProviderList.SeamlessGameGameTypeList
    );
    const { providers } = useGameEntryComponent();
    const { drawer } = useGameEntryOverlay();
    onBeforeRouteUpdate(() => {
      drawer.value = false;
    });
    const activeTab = ref("TopGames");
    const setActiveTab = () => {
      if (route.name === "games" && !route.params.filter) return;
      const parts = String(route.params.filter).split("_");
      activeTab.value = parts.length > 1 ? parts[0] : parts.join();
    };
    watch(
      () => route.params,
      () => {
        setActiveTab();
      }
    );
    onMounted(() => {
      setActiveTab();
    });
    return {
      handleImportImage,
      gameTypes,
      providers,
      TopNewTypes,
      modules: [Navigation],
      isGamePage,
      activeTab,
    };
  },
});
</script>
<style scoped>
.swiper {
  padding-top: 8px;
}
</style>
<style>
.games-types__item-link {
  display: block;
  width: 48px;
  height: 48px;
  margin-bottom: 10px;
  background-color: var(--button-bg);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 12px;
  background-repeat: no-repeat;
  background-position: center;
  -webkit-transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, -webkit-box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s;
  transition: background 0.4s ease-out, box-shadow 0.4s, -webkit-box-shadow 0.4s;
}
.games-types__item-link.active {
  background-color: var(--primary);
}

.game-filter-icon {
  max-width: 24px;
  max-height: 24px;
  margin: 12px;
}
.remove-scroll-bar::-webkit-scrollbar {
  display: none;
}
.remove-scroll-bar {
  -ms-overflow-style: none; /* IE and Edge */
  scrollbar-width: none; /* Firefox */
}
</style>
